/* GCC */

#include <fstream>
#include <vector>

const int uninitialized = -1;

struct Point
{
    int x,y;
};

int main()
{
    std::ifstream in("nests.in");
    int n;
    in >> n;
    std::vector<Point> nest(n);
    for(int i = 0;i < nest.size();i++)
        in >> nest[i].x >> nest[i].y;
    in.close();
    std::vector<int> parent(n,uninitialized);
    std::vector<int> left(n,uninitialized);
    std::vector<int> right(n,uninitialized);
    int root = 0;
    for(int i = 1;i < nest.size();i++)
    {
        int current = i-1;
        while(current != root && nest[current].y < nest[i].y)
            current = parent[current];
        if(current == root && nest[current].y < nest[i].y)
        {
            parent[root] = i;
            left[i] = root;
            root = i;
        }
        else
        {
            parent[i] = current;
            if(right[current] != uninitialized)
            {
                parent[right[current]] = i;
                left[i] = right[current];
            }
            right[current] = i;
        }
    }
    unsigned long long answer = 0;
    for(int i = 0;i < nest.size();i++)
    {
        if(i != root)
        {
            answer += (unsigned long long)std::abs(nest[i].x - nest[parent[i]].x)+
                      (unsigned long long)std::abs(nest[i].y - nest[parent[i]].y);
        }
    }
    std::ofstream out("nests.out");
    out << answer << std::endl;
    out.close();
}
