/* GCC */

#include <fstream>
#include <vector>

bool check(const std::vector<std::vector<int> >& square)
{
    int half = square.size()/2;
    int value[2][2] = {{square[0][0],square[0][half]},{square[half][0],square[half][half]}};
    for(int i = 0;i < 2;i++)
        for(int j = 0;j < 2;j++)
            for(int u = i*half;u < (i+1)*half;u++)
                for(int v = j*half;v < (j+1)*half;v++)
                    if(square[u][v] != value[i][j])
                        return false;
    return true;
}

int main()
{
    std::ofstream out("square.out");
    std::ifstream in("square.in");
    int t;
    in >> t;
    for(int _ = 0;_ < t;_++)
    {
        int n;
        in >> n;
        std::vector<std::vector<int> > square(2*n,std::vector<int>(2*n));
        for(int i = 0;i < square.size();i++)
            for(int j = 0;j < square[i].size();j++)
                in >> square[i][j];
        if(check(square))
            out << 0;
        else
            out << -1;
        out << std::endl;
    }
    in.close();
    out.close();
}
