/* GCC */
#include <stdio.h>
#include <algorithm>
#include <vector>
using namespace std;

int perm[24][5] = {
{0,1,2,3,0},{0,1,3,2,1},{0,2,1,3,1},{0,2,3,1,0},{0,3,1,2,0},{0,3,2,1,1},
{1,0,2,3,1},{1,0,3,2,0},{1,2,0,3,0},{1,2,3,0,1},{1,3,0,2,1},{1,3,2,0,0},
{2,0,1,3,0},{2,0,3,1,1},{2,1,0,3,1},{2,1,3,0,0},{2,3,0,1,0},{2,3,1,0,1},
{3,0,1,2,1},{3,0,2,1,0},{3,1,0,2,0},{3,1,2,0,1},{3,2,0,1,1},{3,2,1,0,0}};
int size;
int fld[201][201], hlp[101][101];
vector<int> ans;

inline void rotate(int k){
       if (k > 0) for(int i = 1; i < size+1; i++) swap(fld[k][i], fld[k][2*size+1-i]);
       if (k < 0) for(int i = 1; i < size+1; i++) swap(fld[i][-k], fld[2*size+1-i][-k]);
       ans.push_back(k);
}

bool buildHlp(){
     int bn[4] = {fld[1][1], fld[2*size][1], fld[1][2*size], fld[2*size][2*size]};
     for(int i = 1; i < size+1; i++){
       for(int j = 1; j < size+1; j++){
         int kn[4] = {fld[i][j], fld[2*size+1-i][j], fld[i][2*size+1-j], fld[2*size+1-i][2*size+1-j]};
         int t = -1;
         for(int k = 0; k < 24; k++){
           if(bn[0] == kn[perm[k][0]] && bn[1] == kn[perm[k][1]] &&
              bn[2] == kn[perm[k][2]] && bn[3] == kn[perm[k][3]]){
                    if (t == -1) t = perm[k][4];
                    else t = 0;
              }
         }
         hlp[i][j] = t;
         if (t == -1) return false;
       }
     }
     return true;
}

void solve(){
     if (!buildHlp()) return;
     for(int i = 1; i < size+1; i++) if (hlp[i][1] == 1) rotate(i);
     buildHlp();
     for(int i = 1; i < size+1; i++){
       int sum = 0;
       for(int j = 1; j < size+1; j++) sum += hlp[j][i];
       if (sum == size){ sum = 0; rotate(-i);}
       if (sum != 0){ ans.clear(); return; }
     }

     int bn[4] = {fld[1][1], fld[2*size][1], fld[1][2*size], fld[2*size][2*size]};     
     for(int i = 1; i < size+1; i++){
       for(int j = 1; j < size+1; j++){
         if (fld[i][2*size+1-j] == bn[0]){
           rotate(i); rotate(-j);
           rotate(i); rotate(-j);
         }
         else if(fld[2*size+1-i][j] == bn[0]){
           rotate(-j); rotate(i);
           rotate(-j); rotate(i);
         }
         else if(fld[2*size+1-i][2*size+1-j] == bn[0]){
           rotate(i); rotate(-(2*size+1-j));
           rotate(i); rotate(-(2*size+1-j));
         }
         
         if (fld[2*size+1-i][j] == bn[2]){
           rotate(-(2*size+1-j)); rotate((2*size+1-i));
           rotate(-(2*size+1-j)); rotate((2*size+1-i));
         }
         else if (fld[2*size+1-i][2*size+1-j] == bn[2]){
           rotate((2*size+1-i)); rotate(-(2*size+1-j));
           rotate((2*size+1-i)); rotate(-(2*size+1-j));
         }
       }
     }
     bn[0] = fld[1][1], bn[1] = fld[2*size][1], bn[2] = fld[1][2*size], bn[3] = fld[2*size][2*size];     
     for(int i = 1; i < size+1; i++){
        for(int j = 1; j < size+1; j++){
          if (fld[2*size+1-i][j] == bn[3]){
            if (bn[0] == bn[2]){
                   rotate(-j); rotate(2*size+1-i);
                   rotate(-j); rotate(2*size+1-i);
                   rotate(i); rotate(-j);
                   rotate(i); rotate(-j);
            }
            else if (bn[0] == bn[3]){
                   rotate(2*size+1-i); rotate(-j);
                   rotate(2*size+1-i); rotate(-j);
            }
            else if(bn[2] == bn[1]){
                   rotate(2*size+1-i); rotate(-(2*size+1-j));
                   rotate(2*size+1-i); rotate(-(2*size+1-j));
            }
            else if(bn[2] == bn[3]){
                   rotate(-(2*size+1-j)); rotate(2*size+1-i);
                   rotate(-(2*size+1-j)); rotate(2*size+1-i);
            }
         }
        }
     }
     
     ans.insert(ans.begin(), ans.size());
}

int main(){
    freopen("square.in", "r", stdin);
    freopen("square.out", "w", stdout);
    int t; scanf("%d", &t);
    for(int k = 0; k < t; k++){
         scanf("%d", &size);
         for(int i = 1; i < 2*size+1; i++) for(int j = 1; j < 2*size+1; j++) scanf("%d", &fld[i][j]);
         solve();
         if (ans.size() == 0) printf("-1\n");
         else{
              printf("%d\n", ans[0]);
              for(int i = 1; i < ans.size(); i++)
                printf("%+d\n", ans[i]);
              ans.clear();
         }
    }
}
